<template>
  <div class="d-date">
    <label v-if="!hideLabel" :class="[inError ? 'in-error' : '']" v-html="getTitle" />
    <datepicker
      v-model="value"
      :input-class="['w-full', classes, inError ? 'in-error-border' : '']"
      :style="styles"
      :minimum-view="minimumView"
      :maximum-view="maximumView"
      :disabled-dates="disabledDates"
      :placeholder="placeholder"
      :format="format"
      monday-first
      name="d-date"
      :disabled="disabled"
      :language="currentLanguage"
      :open-date="openDate"
      @input="updateInput"
    />
  </div>
</template>

<script>
import Datepicker from "vuejs-datepicker";
import * as datePickerLang from "vuejs-datepicker/dist/locale";

export default {
  components: {
    Datepicker
  },
  props: {
    disabled: {
      required: false,
      type: Boolean,
      default: false
    },
    label: {
      required: false,
      type: String,
      default: "&nbsp"
    },
    placeholder: {
      required: false,
      type: String,
      default: ""
    },
    disabledDates: {
      required: false,
      type: Object,
      default: () => {}
    },
    value: {
      required: false,
      type: [Object, String, Number, Date],
      default: ""
    },
    format: {
      // text or number
      required: false,
      type: String,
      default: "dd/MM/yyyy"
    },
    minimumView: {
      required: false,
      type: String,
      default: "day"
    },
    maximumView: {
      required: false,
      type: String,
      default: "day"
    },
    inError: {
      required: false,
      type: Boolean,
      default: false
    },
    required: {
      required: false,
      type: Boolean,
      default: false
    },
    classes: {
      required: false,
      type: String,
      default: ""
    },
    hideLabel: {
      required: false,
      type: Boolean,
      default: false
    },
    styles: {
      required: false,
      type: String,
      default: ""
    },
    openDate: {
      required: false,
      type: String, 
      default: ""
    }
  },
  data() {
    return {
      currentLanguage: datePickerLang[this.$root.$i18n.locale]
    };
  },
  computed: {
    getTitle() {
      let append = "";
      if (this.required) {
        append = " *";
      }
      return `${this.label}${append}`;
    }
  },
  watch: {},
  methods: {
    updateInput() {
      this.$emit("input", this.value);
    }
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/_variables.scss";

.d-date {
  // .vs-input-primary .vs-input--input:focus {
  // 	border-color: $d-input-focus-color !important;
  // }
  label {
    font-size: $d-input-label-size;
    padding-left: $d-input-label-padding;
  }

  .in-error {
    color: red !important;
  }

  .in-error-border {
    border-color: red !important;
  }
}
</style>
